/*  Exile - IRC to Relational Database Gateway
 *  Copyright (C) 2002 Lucas Nussbaum <lucas@lucas-nussbaum.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: misc.h 1731 2006-08-14 04:20:17Z sirvulcan $
 */

#ifndef _MISC_H_
#define _MISC_H_

#include <limits.h>

#define HOSTLEN         75
#define SOCKIPLEN       15
#define KEY 		45432
#define KEY2		76934
#define KEY3		98336

char *strscpy(char *d, const char *s, size_t len);
char *stristr(char *s1, char *s2);
char *strnrepl(char *s, int size, const char *old, const char *new);

int dotime(const char *s);
void strtolwr(char *ch);

char *unsigned32ToDotQuad(unsigned long int ip);
unsigned int base64toint(const char *s);
const char* inttobase64(char* buf, unsigned int v, unsigned int count);
char *mysep(char **sepstr, char *delim);

void set_geoip_info(int nickid, char *hostname);
void unset_geoip_info(int nickid);
void unset_geoip_info_cleanup(int nickid);


/*
 * Tables used for translation and classification macros
 */
extern const char ToLowerTab_8859_1[];
extern const char ToUpperTab_8859_1[];

/*
 * Translation macros for channel name case translation
 * NOTE: Channel names are supposed to be lower case insensitive for
 * ISO 8859-1 character sets.
 */
#define ToLower(c)        (ToLowerTab_8859_1[(c) - CHAR_MIN])
#define ToUpper(c)        (ToUpperTab_8859_1[(c) - CHAR_MIN])

#define NTL_IRCCL   0x0001  /* Force toLower() in ch-name          */
#define IsChannelLower(c)  (IRCD_CharAttrTab[(c) - CHAR_MIN] & NTL_IRCCL)
extern const unsigned int  IRCD_CharAttrTab[];

int irc_tolower(char c);

#endif
